C
C------------------------------------------------------
c      SUBROUTINE BARIC(Q,INF,ISUP,BAR,EPLA4,INDEX)
      INTEGER FUNCTION BARIC(Q,INF,ISUP,BAR,EPLA4,INDEX)
C------------------------------------------------------
      INCLUDE 'INTEST.TXT'
      REAL Q(NCHA)
      REAL BAR
      REAL CM, EPLA4, ENN
      INTEGER INF,ISUP,INDEX, LL
      COMMON / SHIFT / SHIFT
      SAVE / SHIFT /
      DATA CM / 0. /
c      DATA EPLA4 / 0. /
      DATA ENN / 0. /

      BARIC = 0

      LL = 0
      CM = 0.
      EPLA4 = 0.
      if ( index*Q(1) .eq. -2000.323311 ) then
c         index = 10
         print *,' BEWARE!'
         print *,' this is the GHOST of the compilation '
         print *,' you have awakened me too soon '
         print *,' I will launch an anatema against you!'
      endif
      DO LL = INF,ISUP
        ENN = Q(LL)
        IF (ENN.GT.EMIN) THEN
C
          CALL MILLIM(LL,RMM)
C
          CM = CM + RMM * ENN
          EPLA4 = EPLA4 + ENN
        ENDIF
      ENDDO
      IF (EPLA4.EQ.0) GO TO 300
      BAR = CM / EPLA4
      GOTO 400
C
  300 INDEX = 0
      GOTO 500
C
  400 INDEX = 1
C
  500 CONTINUE
      RETURN
      END
C

      SUBROUTINE NOINTER(IGOOD)
C-
C-   Created  20-OCT-1994   MIRKO BOEZIO
C-
      INCLUDE 'INTEST.TXT'
C      
      REAL BAR(2,NPLAV)
      REAL RIL(NCHA/2)
      INTEGER IBAR(2,NPLAV)
      INTEGER NPIANI
      COMMON/ ANGOLO / BAR, IBAR
      SAVE / ANGOLO /
      COMMON / GENERAL / RIG, RMASS
      SAVE / GENERAL /
C
      NPIANI = 0
C
      EMAX = 2. * (RIG * RIG + RMASS * RMASS) / (RIG * RIG)
C
      IF (RIG.NE.0) NPIANI = INT( ANINT( 9. + LOG(ABS(RIG)) ) )
C
      IF ( NPIANI.gt.NPLA ) NPIANI = NPLA
      IF ( NPIANI.lt.1 )  NPIANI = 1
C
      DO K = 1,NCHA/2
         RIL(K) = 1000.
      ENDDO
C
      NGIR = 0
      IBAD = 0
      IGOOD = 0
      DO M = 1,2
        DO J = 1,NPIANI
          DO K = 1,NGIR
            RIL(K) = 1000.
          ENDDO
C
          NNN = 0
          BB = BAR(M,J)
C
C EM: IF TRACK EXIT THE CALORIMETER DO NOT CONSIDER THAT PLANE
C
          IF (BB.LT.-6..OR.BB.GT.246.) GOTO 5
C
C END EM
C
          NGIR = NCL(M,J)
          IF (NGIR.EQ.0) GOTO 5
          IF (NGIR.GT.1) IBAD = IBAD + 1
          IF (NGIR.GT.1) GOTO 5
          DO L = 1,NGIR
            RIL(L) = ABS(CLUS(M,J,L) - BB)
          ENDDO
          MM = NCHA/2
          LK = LVMIN(RIL,MM)
C
          IF (RIL(LK).LE.4.AND.CLUS(M,J,LK+NCHA/2).LT.EMAX) 
     &         IGOOD = IGOOD + J
C
    5     CONTINUE
C
        ENDDO
      ENDDO
C

c  999 RETURN
      RETURN
      END

C
C---------------------------------------------------------------------
      SUBROUTINE LATERALE(RQT1,RQT2)
C---------------------------------------------------------------------
C RQT1 (IT WILL BE CALLED QTRACK IN THE N-TUPLE) IS THE SUM OF THE DETECTED
C ENERGY IN THE STRIP ALONG THE TRACK AND THE TWO CLOSEST STRIPS . FOR ALL THE
C LAYERS . RQT2 (IS NOT USED IN THE N-TUPLA) IS THE TOTAL ENERGY MINUS RQT1 .
C
      INCLUDE 'INTEST.TXT'
C
      INTEGER A,B, INPIA
      INTEGER IBAR(2,NPLAV)
      REAL BAR(2,NPLAV)
      REAL RQT1, RQT2
      COMMON / ANGOLO / BAR, IBAR
      SAVE / ANGOLO /
C
      RQT1 = 0.
      RQT2 = 0.
C
      INPIA = 1
C     
      DO I = INPIA, NPLA
         A = IBAR(1,I)
C     
C     EM
C     
         IF (A.EQ.-1) GOTO 600
C     
C     END EM
C     
         IF (A.LE.2) A = 2
         IF (A.GE.NCHA) A = NCHA - 1
         DO J = A-1,A+1
            IF (DEXY(1,I,J).GE.EMIN) RQT1 = RQT1 + DEXY(1,I,J)
         ENDDO
C
         IF ((A-2).GE.1) THEN
            DO J=1,A-2
               PXY = DEXY(1,I,J)
               IF (PXY.GE.EMIN) RQT2 = RQT2 + PXY
            ENDDO
         ENDIF
C
         IF ((A+2).LE.NCHA) THEN
            DO J=A+2,NCHA
               PXY = DEXY(1,I,J)
               IF (PXY.GE.EMIN) RQT2 = RQT2 + PXY
            ENDDO
         ENDIF
C
c         print *,' I ',I,' A ',RQT1
 600     CONTINUE
C
         B = IBAR(2,I)
C
C     EM
C
         IF (B.EQ.-1) GOTO 700
C
C     END EM
C
         IF (B.LE.2) B = 2
         IF (B.GE.NCHA) B = NCHA - 1
         DO J = B-1,B+1
            IF (DEXY(2,I,J).GE.EMIN) RQT1 = RQT1 + DEXY(2,I,J)
c            print *,' ==> J ',j,' dexy ',DEXY(2,I,J)
         ENDDO
C     
         IF ((B-2).GE.1) THEN
            DO J=1,B-2
               PXY = DEXY(2,I,J)
               IF (PXY.GE.EMIN) RQT2 = RQT2 + PXY
            ENDDO
         ENDIF
C     
         IF ((B+2).LE.NCHA) THEN
            DO J=B+2,NCHA
               PXY = DEXY(2,I,J)
               IF (PXY.GE.EMIN) RQT2 = RQT2 + PXY
            ENDDO
         ENDIF
C
c         print *,' I ',I,' B ',RQT1
 700     CONTINUE
      ENDDO
C     
C
c 800  RETURN
      RETURN
      END

      SUBROUTINE DIRECTION(DEVIA)
C-----------------------------------------------------
C-
C-   Purpose and Methods : PROGRAM THAT DETERMINES THE
C-   TRACK PROJECTIONS ON THE PLANE XZ AND YZ USING
C-   ONLY CALORIMETER INFORMATION .
C-
C-   Inputs  :
C-   Outputs :
C-   Controls:
C-
C-   Created   9-FEB-1994   MIRKO BOEZIO
C-   Modified  21-FEB-2003   MIRKO BOEZIO . ADAPTED TO
C-   BE USED FOR PAMELA CALORIMETER .
C-
C------------------------------------------------------

      IMPLICIT NONE

      INCLUDE 'INTEST.TXT'

      REAL FLIMIT, FLIMIT2
      INTEGER NVAR,NPAR
      PARAMETER (NVAR=1,NPAR=2)          
c      PARAMETER (FLIMIT=10000)
c      PARAMETER (FLIMIT2=2000)
c      PARAMETER (FLIMIT=500)
      PARAMETER (FLIMIT=2000)
      PARAMETER (FLIMIT2=500)
      REAL X(NPLAV),Y(NPLAV),W(NPLAV)
      REAL DEVIA(2),TG(2)
      REAL BAR(2,NPLAV)
      REAL A, B, VAR
      REAL SA, SB, SVAR
      REAL SSA, SSB, SSVAR
      REAL PIANO(NPLAV)
      REAL VARFIT(2)

      INTEGER ICONT, M, I, SNPFIT,SSNPFIT
      INTEGER NPFIT(2), CHTRACK,IWPL(2)
      INTEGER FORCEMODE
      
      INTEGER IBAR(2,NPLAV)      
      COMMON/ANGOLO/BAR,IBAR
      SAVE /ANGOLO/

      REAL CX, CY
      COMMON/WHERE/CX,CY,PIANO
      SAVE /WHERE/

      COMMON/CALOFIT/VARFIT,NPFIT,IWPL,CHTRACK
      SAVE/CALOFIT/
C
      ICONT = 0
      DEVIA(1) = 0.
      DEVIA(2) = 0.
      CX = 0.
      CY = 0.
C
      NPFIT(1) = NPLA
      NPFIT(2) = NPLA
      VARFIT(1) = 0.
      VARFIT(2) = 0.      
C
      FORCEMODE = -1
      IF (FMODE(1).GE.1000.AND.FMODE(2).GE.1000) THEN
         FORCEMODE = FMODE(1)-1000
      ENDIF         
C
C THE FIT IS PERFORMED WHEN THERE ARE AT LEAST TWO 
C LAYERS WITH SIGNAL . FOR THE FIT THE CLUSTER WITH THE
C HIGHEST DETECTED ENERGY IS USED . 
C
      DO M = 1,2
         SA = 0
         SB = 0
         SVAR = 0
         FMODE(M) = 0
 10      CONTINUE         
         ICONT = 0
         CALL VZERO(X,NPLAV)
         CALL VZERO(Y,NPLAV)
         CALL VZERO(W,NPLAV)
         DO I = 1,NPLA
C    
            IF (MOD(M,2).EQ.0) THEN
               X(I) = PIANO(I)
C               X(I) = PIANO(I) - 5.81
            ELSE
               X(I) = PIANO(I) - 5.81
C               X(I) = PIANO(I)                  
            ENDIF
            Y(I) = 0.
C
C
C
            IF ((FMODE(M).EQ.0.AND.FORCEMODE.EQ.-1)
     +           .OR.FORCEMODE.EQ.0) THEN
               IF (NCL(M,I).GE.1) THEN
                  ICONT = ICONT + 1
                  Y(I) = CLUS(M,I,1)
                  W(I) = ((CLUS(M,I,1+NCHA/2)**0.79))**2.
                  IF (W(I).GT.2000.) THEN
                     W(I) = 2000.
C                     Y(I) = 0. 
C                     ICONT = ICONT -1
                  ENDIF
               ENDIF
            ENDIF
C
C No weigth and less cluster per plane
C
            IF((FMODE(M).EQ.1.AND.FORCEMODE.EQ.-1).OR.
     +           FORCEMODE.EQ.1) THEN
               IF (NCL(M,I).GE.1.AND.NCL(M,I).LE.2) THEN
                  ICONT = ICONT + 1
                  Y(I) = CLUS(M,I,1)
                  W(I) = ((CLUS(M,I,1+NCHA/2)**0.29))**2.
c                  W(I) = 1.
               ENDIF
c               IF (W(I).GT.2000.) THEN
cx                  W(I) = 2000.
cc                  Y(I) = 0. 
cc                  ICONT = ICONT -1
c               ENDIF
            ENDIF
c
c One cluster per plane
c
            IF((FMODE(M).EQ.2.AND.FORCEMODE.EQ.-1).OR.
     +           FORCEMODE.EQ.2) THEN
               IF (NCL(M,I).EQ.1) THEN
                  ICONT = ICONT + 1
                  Y(I) = CLUS(M,I,1)
                  W(I) = ((CLUS(M,I,1+NCHA/2)**0.79))**2.
c                  W(I) = 1.
               ENDIF
            ENDIF
c            if (Y(I).eq.0.or.W(I).eq.2000.) NPFIT(M) = NPFIT(M) - 1
            if (Y(I).eq.0.) NPFIT(M) = NPFIT(M) - 1
         ENDDO
C     
         
         A = 0.
         B = 0.
         VAR = 0.
c         print *,' icont = ',icont
         IF (ICONT.GE.2) THEN
            CALL LFITW(X,Y,W,NPLA,0,A,B,VAR)
         ELSE
            NPFIT(M) = 0
         ENDIF
C
         IF (FORCEMODE.EQ.-1) THEN
C     
C     TRY A BETTER FIT IF VAR IS BIG ON THE FIRST TRY
C     
            IF ((ABS(VAR).GT.FLIMIT.OR.VAR.EQ.0.)
     &           .AND.FMODE(M).EQ.0) THEN
               SVAR = VAR
               SB = B
               SA = A
               SNPFIT = NPFIT(M)
               NPFIT(M) = NPLA
               FMODE(M) = 1
               GOTO 10
            ENDIF
C     
C     TRY AGAIN IF STILL BAD AND WE HAVE AT LEAST 10 POINT TO MAKE THE FIT
C     
            IF ((ABS(VAR).GT.FLIMIT2.OR.VAR.EQ.0.).AND.FMODE(M).EQ.1
     &           .AND.SNPFIT.GT.5) THEN
               SSVAR = VAR
               SSB = B
               SSA = A
               SSNPFIT = NPFIT(M)
               NPFIT(M) = NPLA
               FMODE(M) = 2
               GOTO 10
            ENDIF          
C     
C     IF WE ARE AT THE THIRD TRY AND THE FIT IS WORST THAN THE SECOND TRY TAKE THE FIRST TRY
C     
            IF (FMODE(M).EQ.2) THEN
               IF (ABS(VAR).GT.ABS(SSVAR).OR.ABS(VAR).EQ.0.
     &              .OR.NPFIT(M).LE.4) THEN
                  FMODE(M) = 1
                  VAR=SSVAR
                  B = SSB
                  A = SSA
                  NPFIT(M) = SSNPFIT
               ENDIF
            ENDIF
C     
C     IF THE SECOND TRY AND THE FIT IS WORST THAN THE FIRST TRY TAKE THE FIRST TRY
C     
            IF (FMODE(M).EQ.1) THEN
               IF (ABS(VAR).GT.ABS(SVAR).OR.ABS(VAR).EQ.0.) THEN
                  FMODE(M) = 0
                  VAR=SVAR
                  B = SB
                  A = SA
                  NPFIT(M) = SNPFIT
               ENDIF
            ENDIF
         ENDIF
C
         VARFIT(M) = VAR
         IF (M.EQ.1) CX = B
         IF (M.EQ.2) CY = B
         DEVIA(M) = A
         TG(M) = A
C
      ENDDO
C

c  500 CONTINUE
      CONTINUE
      RETURN
      END

C
C---------------------------------------------------------------------
      SUBROUTINE LASTRISCIA(BAR,IBAR)
C---------------------------------------------------------------------
C TRASFORMA UN VALORE IN mm NELL'EQUIVALENTE VALORE IN NUMERO DI STRISCIA .
C
      INCLUDE 'INTEST.TXT'
C
      COMMON / SHIFT / SHIFT
      SAVE / SHIFT /
C
C EM: IF TRACK GO OUT OF THE CALORIMETER GIVE BACK AS STRIP VALUE -1 TO FLAG THE SITUATION
C
      IF ( BAR.LT.-6..OR.BAR.GT.246. ) THEN
         IBAR = -1
         GOTO 500
      ENDIF
C
C END EM
C
      BBAR = BAR - SHIFT
      IBAR = 0
      DO L = 1, NCHA
        ALUNG = INT((FLOAT(L) - 1.) / 32.) * ADIST + AA
        II = L - 1
        K = MOD(II,32)
        RLINF = FLOAT(K) * 2.44 + ALUNG
        RLSUP = FLOAT(K + 1) * 2.44 + ALUNG
        IF (BBAR.GT.RLINF.AND.BBAR.LT.RLSUP) THEN
          IBAR = L
          GO TO 500
        ENDIF
      ENDDO
C
C SE BAR SI TROVA SU UN'AREA MORTA SI PRENDE LA STRISCIA INFERIORE PIU`
C PROSSIMA TRANNE QUANDO SI TRATTA DELLA PRIMA AREA MORTA NEL QUAL CASO SI
C PRENDE IBAR = 1 .
C
      IF (IBAR.EQ.0.AND.BBAR.GT.0.0001) THEN
        LK = INT(BBAR / ADIST)
        DIS = BBAR - ADIST * FLOAT(LK+1) 
        IF (DIS.LT.-1.96) THEN
           IBAR = 32 * LK
        ELSE IF (DIS.GE.-1.96.AND.DIS.LE.-0.5) THEN
           IBAR = 32 * (LK + 1)
        ELSE IF (DIS.GT.-0.5.AND.DIS.LE.0.) THEN
           IBAR = 32 * (LK + 1) + 1
        ELSE
           PRINT *,'PROBLEMS :',BBAR
        ENDIF
        IF (IBAR.EQ.0) IBAR = 1
      ENDIF
C
      IF ( IBAR.LE.0 ) IBAR = 1
      IF ( IBAR.GT.96 ) IBAR = 96
C
  500 CONTINUE
      RETURN
      END
C
